FreePBX
=========

FreePBX is an Open Source GUI (graphical user interface) that controls and manages [Asterisk (PBX)].
Please see the included license file in the module for license information
FreePBX is a Registered Trademark of [Sangoma Technologies, Inc].

Version
----

13

Tech
-----------
FreePBX uses a number of open source projects to work properly:

#### Backend
* [Asterisk] - Asterisk is a software implementation of a telephone private branch exchange (PBX) (Supported Versions 11 through 13). License GPL
* [Pear Console::Getopt] - This is a PHP implementation of "getopt" supporting both short and long options. License PHP License
* [PHP Data Objects] - The PHP Data Objects (PDO) extension defines a lightweight, consistent interface for accessing databases in PHP. License PHP License
* [dialparties.agi] - Ported to PHP by the FreePBX community, Originally by Zac Sprackett.  License GPL
* [CDR (Call Detail Records) Application] - Originally by Arezqui Belaid, License GPL (depends on JPGraph which is QPL)
* [CssMin] - A (simple) css minifier with benefits. By Joe Scylla, Copyright (c) 2008 - 2010. License MIT
* [Codeigniter helpers/librarires] - Copyright (c) 2008 - 2011, EllisLab, Inc., All rights reserved. License GPL

#### Frontend
* [Chosen] - Chosen is a jQuery plugin that makes long, unwieldy select boxes much more user-friendly. License MIT
* [Class.js] - Simple JavaScript Inheritance. License MIT
* [HTML5-History-API] - HTML5 History API expansion for browsers not supporting pushState, replaceState. License GPL or MIT
* [html5shiv] - This script is the defacto way to enable use of HTML5 sectioning elements in legacy Internet Explorer. License GPL or MIT
* [jed] - Gettext Style i18n for Modern JavaScript Apps. License WTFPL
* [Bootstrap Table] - An extended Bootstrap table with radio, checkbox, sort, pagination, and other added features. License MIT
* [modernizer] - Modernizr tells you what HTML, CSS and JavaScript features the user’s browser has to offer. License MIT
* [Outdated Browser] - A time saving tool for developers. It detects outdated browsers and advises users to upgrade to a new version. License MIT
* [Respond JS] - A fast & lightweight polyfill for min/max-width CSS3 Media Queries (for IE 6-8, and more). License MIT
* [Progress JS] - Polyfill for the HTML5 <progress> element. License MIT
* [Sortable] - a minimalist JavaScript library for reorder-able drag-and-drop lists on modern browsers and touch devices. No jQuery. Supports Meteor, AngularJS, React and any CSS library, e.g. Bootstrap. License MIT
* [toastr] - Simple javascript toast notifications. License MIT
* [Typeahead] - a flexible JavaScript library that provides a strong foundation for building robust typeaheads. License MIT
* [zxcvbn] - Realistic password strength estimation - Dan Wheeler (Dropbox). License MIT

##### jQuery Specific
* [jQuery] - A multi-browser JavaScript library designed to simplify the client-side scripting of HTML. License MIT
* [jQueryUI] - jQuery UI is a JavaScript library that provides abstractions for low-level interaction and animation, advanced effects and high-level, themeable widgets, built on top of the jQuery JavaScript library, that can be used to build interactive web applications. License MIT
* [jQuery UI Bootstrap] - Some work based off of this project which was started to bring the beauty and ease-of-use of Twitter Bootstrap to jQuery UI widgets. License MIT
* [jQuery Migrate] - This plugin can be used to detect and restore APIs or features that have been deprecated in jQuery and removed as of version 1.9. License MIT
* [jQuery Autosize] - A small, stand-alone script to automatically adjust textarea height. License MIT
* [jQuery Cookie] - A simple, lightweight jQuery plugin for reading, writing and deleting cookies. License MIT
* [jQuery File Upload] - File Upload widget with multiple file selection, drag&drop support, progress bar, validation and preview images, audio and video for jQuery. Supports cross-domain, chunked and resumable file uploads. Works with any server-side platform (Google App Engine, PHP, Python, Ruby on Rails, Java, etc.) that supports standard HTML form file uploads. License MIT
* [jQuery Hotkeys] - jquery.hotkeys plugin lets you easily add and remove handlers for keyboard events anywhere in your code supporting almost any key combination. It takes one line of code to bind/unbind a hot key combination
* [jPlayer] - jPlayer : HTML5 Audio & Video for jQuery
* [jQuery Numeric] - Allows only valid characters (i.e. numbers) to be typed into a text box. Can take negative numbers and a decimal point.
* [Selector Set] - An efficient data structure for matching and querying elements against a large set of CSS selectors. License MIT
* [jQuery Smart Wizard] - flexible jQuery plug-in that gives wizard like interface

Visuals
-----------
FreePBX uses a number of visual graphics packages to render properly:
* [Bootstrap] - a free collection of tools for creating websites and web applications. It contains HTML and CSS-based design templates for typography, forms, buttons, navigation and other interface components, as well as optional JavaScript extensions. License MIT
* [Silk Icon Set] - Version 1.3, Creative Commons Attribution 2.5 License: http://creativecommons.org/licenses/by/2.5/, Originally by Mark James
* [Font Awesome] Font Awesome by Dave Gandy. Licence(s) http://fontawesome.io/license/

Music
-----------
FreePBX incorporates a number of royalty-free, creative commons licensed music files. These files are distributed under the Creative Commons Attribution-ShareAlike 3.0 license through explicit permission from their authors. The license can be found at: http://creativecommons.org/licenses/by-sa/3.0/

* [macroform-cold_day] - Paul Shuler (Macroform), paulshuler@gmail.com

* [macroform-robot_dity] - Paul Shuler (Macroform), paulshuler@gmail.com

* [macroform-the_simplicity] - Paul Shuler (Macroform), paulshuler@gmail.com

* [manolo_camp-morning_coffee] - Manolo Camp, beatbastard@gmx.net

* [reno_project-system] - Reno Project, renoproject@hotmail.com

Installation
--------------

```sh
./install
```

License
----
Please see the included license file in the module for license information

*Free Software, Hell Yeah!*

  [asterisk]: http://www.asterisk.org
  [jQueryUI]: http://jqueryui.com
  [jQuery]: http://jquery.com
  [jQuery-migrate]: https://github.com/jquery/jquery-migrate/
  [dialparties.agi]: http://www.sprackett.com
  [CDR (Call Detail Records) Application]: http://www.asterisk-stats.org
  [spandsp]: http://opencall.org
  [Silk Icon Set]: http://www.famfamfam.com/lab/icons/silk/
  [CssMin]: http://opensource.org/licenses/mit-license.php
  [Codeigniter helpers/librarires]: http://codeigniter.com/user_guide/license.html
  [macroform-cold_day]: http://macroform.bandcamp.com/
  [macroform-robot_dity]: http://macroform.bandcamp.com/
  [macroform-the_simplicity]: http://macroform.bandcamp.com/
  [manolo_camp-morning_coffee]: http://ccmixter.org/people/ManoloCamp
  [reno_project-system]: http://www.jamendo.com/en/album/23661
  [pear db]: http://pear.php.net/package/DB
  [pear console::getopt]: http://pear.php.net/package/Console_Getopt
  [bootstrap]: http://getbootstrap.com
  [jQuery UI Bootstrap]: https://github.com/addyosmani/jquery-ui-bootstrap
  [Bootstrap table]: http://bootstrap-table.wenzhixin.net.cn/
  [zxcvbn]: https://github.com/dropbox/zxcvbn
  [Font Awesome]: http://fontawesome.io
  [Chosen]: https://harvesthq.github.io/chosen/
  [Class.js]: http://ejohn.org/blog/simple-javascript-inheritance/
  [HTML5-History-API]: https://github.com/devote/HTML5-History-API
  [html5shiv]: https://github.com/afarkas/html5shiv
  [jed]: https://slexaxton.github.io/Jed/
  [jquery Autosize]: http://www.jacklmoore.com/autosize/
  [jquery cookie]: https://github.com/carhartl/jquery-cookie
  [jQuery File Upload]: https://github.com/blueimp/jQuery-File-Upload
  [jQuery hotkeys]: https://github.com/tzuryby/jquery.hotkeys
  [jPlayer]: http://jplayer.org/
  [jQuery Numeric]: https://github.com/SamWM/jQuery-Plugins/tree/master/numeric/
  [Selector Set]: https://github.com/josh/selector-set
  [jQuery Smart Wizard]: https://github.com/mstratman/jQuery-Smart-Wizard
  [jQuery Migrate]: https://github.com/jquery/jquery-migrate/
  [Sangoma Technologies, Inc]: http://www.sangoma.com/
  [modernizer]: https://modernizr.com/
  [outdated browser]: http://outdatedbrowser.com/en
  [Respond JS]: https://github.com/scottjehl/Respond
  [Progress JS]: https://github.com/LeaVerou/HTML5-Progress-polyfill
  [Sortable]: https://github.com/RubaXa/Sortable
  [toastr]: http://www.toastrjs.com/
  [typeahead]: https://twitter.github.io/typeahead.js/
  [PHP Data Objects]: http://php.net/manual/en/intro.pdo.php
  [Asterisk (PBX)]: http://www.asterisk.org
