# Validators

## Types

  * [Arr](Arr.md)
  * [Bool](Bool.md)
  * [Date](Date.md)
  * [False](False.md)
  * [Float](Float.md)
  * [Instance](Instance.md)
  * [Int](Int.md)
  * [NullValue](NullValue.md)
  * [Numeric](Numeric.md)
  * [Object](Object.md)
  * [String](String.md)
  * [True](True.md)
  * [Type](Type.md)
  * [Xdigit](Xdigit.md)

## Generics

  * [AlwaysInvalid](AlwaysInvalid.md)
  * [AlwaysValid](AlwaysValid.md)
  * [Call](Call.md)
  * [Callback](Callback.md)
  * [FilterVar](FilterVar.md)
  * [Not](Not.md)
  * [Type](Type.md)
  * [When](When.md)

## Comparing Values

  * [Age](Age.md)
  * [Between](Between.md)
  * [Equals](Equals.md)
  * [Max](Max.md)
  * [Min](Min.md)

## Numeric

  * [Between](Between.md)
  * [Bool](Bool.md)
  * [Even](Even.md)
  * [Float](Float.md)
  * [Int](Int.md)
  * [Multiple](Multiple.md)
  * [Negative](Negative.md)
  * [NotEmpty](NotEmpty.md)
  * [Numeric](Numeric.md)
  * [Odd](Odd.md)
  * [PerfectSquare](PerfectSquare.md)
  * [Positive](Positive.md)
  * [PrimeNumber](PrimeNumber.md)
  * [Roman](Roman.md)
  * [Xdigit](Xdigit.md)

## String

  * [Alnum](Alnum.md)
  * [Alpha](Alpha.md)
  * [Between](Between.md)
  * [Charset](Charset.md)
  * [Cntrl](Cntrl.md)
  * [Consonant](Consonant.md)
  * [Contains](Contains.md)
  * [Digit](Digit.md)
  * [EndsWith](EndsWith.md)
  * [Graph](Graph.md)
  * [In](In.md)
  * [Length](Length.md)
  * [Lowercase](Lowercase.md)
  * [NotEmpty](NotEmpty.md)
  * [NoWhitespace](NoWhitespace.md)
  * [Prnt](Prnt.md)
  * [Punct](Punct.md)
  * [Regex](Regex.md)
  * [Slug](Slug.md)
  * [Space](Space.md)
  * [StartsWith](StartsWith.md)
  * [Uppercase](Uppercase.md)
  * [Version](Version.md)
  * [Vowel](Vowel.md)
  * [Xdigit](Xdigit.md)

## Arrays

  * [Arr](Arr.md)
  * [Contains](Contains.md)
  * [Each](Each.md)
  * [EndsWith](EndsWith.md)
  * [In](In.md)
  * [Key](Key.md)
  * [Length](Length.md)
  * [NotEmpty](NotEmpty.md)
  * [StartsWith](StartsWith.md)

## Objects

  * [Attribute](Attribute.md)
  * [Instance](Instance.md)
  * [Length](Length.md)

## Date and Time

  * [Age](Age.md)
  * [Between](Between.md)
  * [Date](Date.md)
  * [LeapDate](LeapDate.md)
  * [LeapYear](LeapYear.md)
  * [MinimumAge](MinimumAge.md)

## Group Validators

  * [AllOf](AllOf.md)
  * [NoneOf](NoneOf.md)
  * [OneOf](OneOf.md)

## Regional

  * [CountryCode](CountryCode.md)
  * [PostalCode](PostalCode.md)
  * [Tld](Tld.md)

## Files

  * [Directory](Directory.md)
  * [Executable](Executable.md)
  * [Exists](Exists.md)
  * [File](File.md)
  * [Readable](Readable.md)
  * [SymbolicLink](SymbolicLink.md)
  * [Uploaded](Uploaded.md)
  * [Writable](Writable.md)

## Banking

  * [Bank](Bank.md)
  * [BankAccount](BankAccount.md)
  * [Bic](Bic.md)

## Other

  * [Cnh](Cnh.md)
  * [Cnpj](Cnpj.md)
  * [Cpf](Cpf.md)
  * [Domain](Domain.md)
  * [Email](Email.md)
  * [HexRgbColor](HexRgbColor.md)
  * [Ip](Ip.md)
  * [Json](Json.md)
  * [MacAddress](MacAddress.md)
  * [NfeAccessKey](NfeAccessKey.md)
  * [Phone](Phone.md)
  * [Sf](Sf.md)
  * [Url](Url.md)
  * [Zend](Zend.md)

## Yes/No

  * [No](No.md)
  * [Yes](Yes.md)

## Alphabetically

  * [Age](Age.md)
  * [AllOf](AllOf.md)
  * [Alnum](Alnum.md)
  * [Alpha](Alpha.md)
  * [AlwaysInvalid](AlwaysInvalid.md)
  * [AlwaysValid](AlwaysValid.md)
  * [Arr](Arr.md)
  * [Attribute](Attribute.md)
  * [Bank](Bank.md)
  * [BankAccount](BankAccount.md)
  * [Between](Between.md)
  * [Bic](Bic.md)
  * [Bool](Bool.md)
  * [Call](Call.md)
  * [Callback](Callback.md)
  * [Charset](Charset.md)
  * [Cnh](Cnh.md)
  * [Cnpj](Cnpj.md)
  * [Cntrl](Cntrl.md)
  * [Consonant](Consonant.md)
  * [Contains](Contains.md)
  * [CountryCode](CountryCode.md)
  * [Cpf](Cpf.md)
  * [CreditCard](CreditCard.md)
  * [Date](Date.md)
  * [Digit](Digit.md)
  * [Directory](Directory.md)
  * [Domain](Domain.md)
  * [Each](Each.md)
  * [Email](Email.md)
  * [EndsWith](EndsWith.md)
  * [Equals](Equals.md)
  * [Even](Even.md)
  * [Executable](Executable.md)
  * [Exists](Exists.md)
  * [False](False.md)
  * [File](File.md)
  * [FilterVar](FilterVar.md)
  * [Float](Float.md)
  * [Graph](Graph.md)
  * [HexRgbColor](HexRgbColor.md)
  * [In](In.md)
  * [Instance](Instance.md)
  * [Int](Int.md)
  * [Ip](Ip.md)
  * [Json](Json.md)
  * [Key](Key.md)
  * [LeapDate](LeapDate.md)
  * [LeapYear](LeapYear.md)
  * [Length](Length.md)
  * [Lowercase](Lowercase.md)
  * [MacAddress](MacAddress.md)
  * [Max](Max.md)
  * [Min](Min.md)
  * [MinimumAge](MinimumAge.md)
  * [Multiple](Multiple.md)
  * [Negative](Negative.md)
  * [NfeAccessKey](NfeAccessKey.md)
  * [No](No.md)
  * [NoWhitespace](NoWhitespace.md)
  * [NoneOf](NoneOf.md)
  * [Not](Not.md)
  * [NotEmpty](NotEmpty.md)
  * [NullValue](NullValue.md)
  * [Numeric](Numeric.md)
  * [Object](Object.md)
  * [Odd](Odd.md)
  * [OneOf](OneOf.md)
  * [PerfectSquare](PerfectSquare.md)
  * [Phone](Phone.md)
  * [Positive](Positive.md)
  * [PostalCode](PostalCode.md)
  * [PrimeNumber](PrimeNumber.md)
  * [Prnt](Prnt.md)
  * [Punct](Punct.md)
  * [Readable](Readable.md)
  * [Regex](Regex.md)
  * [Roman](Roman.md)
  * [Sf](Sf.md)
  * [Slug](Slug.md)
  * [Space](Space.md)
  * [StartsWith](StartsWith.md)
  * [String](String.md)
  * [SymbolicLink](SymbolicLink.md)
  * [Tld](Tld.md)
  * [True](True.md)
  * [Type](Type.md)
  * [Uploaded](Uploaded.md)
  * [Uppercase](Uppercase.md)
  * [Url](Url.md)
  * [Version](Version.md)
  * [Vowel](Vowel.md)
  * [When](When.md)
  * [Writable](Writable.md)
  * [Xdigit](Xdigit.md)
  * [Yes](Yes.md)
  * [Zend](Zend.md)

***

See also:

- [Contributing](../CONTRIBUTING.md)
- [Feature Guide](README.md)
- [Installation](INSTALL.md)
- [License](../LICENSE.md)
